/* ---------------------------------------------------------------------------
   A. Veneziani - Programma in C + Assembly che determina i fattori 
                  di un numero intero

                  Scritto in C++ Builder 6
   --------------------------------------------------------------------------- */

#include "stdio.h"
#include "conio.h"

void main()
{
	int n;

        // effettua un input appogiandosi al C
        printf("Numero di cui trovare i fattori:  ");
	scanf("%i",&n);

	printf("I fattori sono:  ");

	asm {
		MOV ECX,n   // passa n a ECX (registro a 32 bit)
		DEC ECX     // calcola n - 1
Ciclo:
		MOV EAX,n   // inserisce n in DX:AX
		MOV EDX,0d
		DIV ECX     // divide per ECX

		// risultato DIV: resto in EDX e quoziente in EAX
		CMP EDX,0d   // il resto  0 ?
		JNE Non_Scrivo     // se non lo  allora salto la scritta
		                   // in quanto il numero non  fattore

		PUSH ECX    // salva sullo stack il conteggio in ECX
					//prima di chiamare la printf

		}

		printf("%i  ",_ECX);      // output in C

	asm {

		POP ECX     // richiama il valore di ECX salvato

Non_Scrivo:
		DEC ECX         // descrementa ECX  (ECX--)
		CMP ECX,1d      // fino a quando non  1....
		JNE Ciclo       // salta alla label ciclo
	}

	getch();       // blocca l'uscita dal programma

}


